
//+------------------------------------------------------------------+
//|                                                 PeriodOfTime.mq4 |
//|                          Copyright c 2006, Gordago Software Ltd. |
//|                                           http://www.gordago.com |
//+------------------------------------------------------------------+
#property copyright "Copyright c 2006, Gordago Software Ltd."
#property link      "http://www.gordago.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Magenta
//---- input parameters
extern int       prmHour=12;
extern int       prmMinute=15;
extern int       prmPeriod=3;
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,251);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int pos=Bars-counted_bars;
   while(pos>=0){
   
      int iYear = TimeYear(Time[pos]);
      int iMonth = TimeMonth(Time[pos]);
      int iDay = TimeDay(Time[pos]);
      int iHour = TimeHour(prmHour);
      int iMinute = TimeMinute(prmMinute);
      string strdtm = iYear + "." + iMonth + "." + iDay + " " + prmHour + ":" + prmMinute;
      datetime dtm = StrToTime(strdtm);
      datetime dtmto = dtm + prmPeriod * 60 - 1;
		
		if (Time[pos] >= dtm && Time[pos] <= dtmto)
   		ExtMapBuffer1[pos] = High[pos]+Point*2;
	   else
         ExtMapBuffer1[pos] = 0.0;
 	   pos--;
   }
   return(0);
  }
//+------------------------------------------------------------------+
	